; -----------------------------------------------------------------------------
; #####################################################################Begin###
; -----------------------------------------------------------------------------
; Name:               ac'tivAid
; -----------------------------------------------------------------------------
; Version:            0.9.3
; Date:               2005-10-10
; Author:             Wolfgang Reszel fr c't
; Copyright:          2005 Heise Zeitschriften Verlag GmbH & Co. KG
; AutoHotkey Version: 1.0.32.00
; Language:           German/Dutch (+ English GUI)
; Testplatform:       WinXP
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; --- Description -------------------------------------------------------------
; -----------------------------------------------------------------------------

; *** Deutsch *****************************************************************

; Prft auf die richtige AutoHotkey-Version, startet dann das eigentliche
; Skript.

; #################################################################EndHeader###

; -----------------------------------------------------------------------------
; === Global Settings =========================================================
; -----------------------------------------------------------------------------

#singleinstance force

; -----------------------------------------------------------------------------
; === Initialisation ======================================================cd==
; -----------------------------------------------------------------------------

ScriptName         = ac'tivAid
ScriptNameClean    = activAid
ScriptVersion      = 0.9.3
neededAHKversion   = 1.0.32.00

ScriptTitle        = %ScriptName% v%ScriptVersion%

; -----------------------------------------------------------------------------

RegRead, A_AutoHotkeyPath, HKLM, SOFTWARE\AutoHotkey, InstallDir

; sprachabhngige Variablen, Systemsprache wird ermittelt
IniRead, Lng, %ConfigFile%, %ScriptNameClean%, Language
If Lng = ERROR
   StringRight, Lng, A_Language, 2 ; Sprache ermitteln, wenn nicht in INI festgelegt

If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
{
   lng_wrongAHK      = AutoHotkey %neededAHKversion% oder hher wird bentigt.`nBitte besorgen Sie sich die neuste Version.
   lng_newActivAid   = Von ac'tivAid wurde in c't 22/05 mit Version 1.0 eine gnzlich berarbeitete Version vorgestellt.`nDurch das genderte Konzept werden nicht alle Einstellungen mit in die neue Version bernommen.`nSoll die neue Version installiert und die alte im Verzeichnis _backup gesichert werden?`nWenn Sie 'Nein' klicken, finden Sie die neue Version im Verzeichnis _ac'tivAid1 und die alte Version 0.9.3 bleibt aktiv.
}
else if Lng = 13  ; Nederlands
{
   lng_wrongAHK      = AutoHotkey %neededAHKversion% of hoger nodig.`nHaalt u a.u.b. de nieuwste versie op.
   lng_newActivAid   = Version 1.0 is a completly revised version of ac'tivAid, published in c't-magazine 22/05.`nBecause of the new concept some old settings won't be available in the new version.`nDo you want to install the new version while creating a backup of the old version in the _backup-folder?`nIf you press 'no' you can find the new version in the _ac'tivAid1-folder while version 0.9.3 stays active.
}
else        ; = other languages (english)
{
   lng_wrongAHK      = AutoHotkey %neededAHKversion% or high will be needed.`nPlease download the newest version.
   lng_newActivAid   = Version 1.0 is a completly revised version of ac'tivAid, published in c't-magazine 22/05.`nBecause of the new concept some old settings won't be available in the new version.`nDo you want to install the new version while creating a backup of the old version in the _backup-folder?`nIf you press 'no' you can find the new version in the _ac'tivAid1-folder while version 0.9.3 stays active.
}

; Prfen, ob richtige AutoHotkey-Version installiert ist
If A_AHKversion < %neededAHKversion%
{
   If A_IsCompiled <> 1
   {
      MsgBox, 16, %ScriptTitle%, %lng_wrongAHK%
      Run, http://www.autohotkey.com./download/
      ExitApp
   }
}

MsgBox,36, %ScriptTitle%, %lng_newActivAid%

IfMsgBox, Yes
{
   FileCreateDir, _backup
   FileMove, *.*, _backup, 1
   FileMoveDir, include, _backup, 1
   FileMoveDir, WebSearch, _backup, 1
   FileDelete, _backup\ac'tivAid.exe
   FileMove, _backup\ac'tivAid_main.exe, _backup\ac'tivAid.exe
   FileDelete, *.*
   FileMove, _ac'tivaid1\*.*, .
   FileMoveDir, _ac'tivaid1\settings, %A_ScriptDir%, 1
   FileMoveDir, _ac'tivaid1\extensions, %A_ScriptDir%, 1
   FileMoveDir, _ac'tivaid1\development, %A_ScriptDir%, 1
   FileRemoveDir, _ac'tivaid1
   FileAppend, update, update.zip
   Run %A_AutoHotkeyPath%\AutoHotkey.exe ac'tivAid.ahk
}
Else
{
   ;FileMove, %ScriptName%.ahk, %ScriptName%-Checker.ahk , 1
   FileMove, %ScriptName%_main.ahk, %ScriptName%.ahk, 1
   IniWrite, no, %ConfigFile%, %ScriptNameClean%, AutoUpdate
   If A_IsCompiled = 1
   {
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, type cmd.cmd`r`n
      FileAppend, del ac'tivAid.exe`r`n, cmd.cmd
      FileAppend, ren %ScriptName%_main.exe %ScriptName%.exe`r`n, cmd.cmd
      FileAppend, start %ScriptName%.exe`r`n, cmd.cmd
      FileAppend, del cmd.cmd`r`n, cmd.cmd
      Run, cmd.cmd,, Hide
      ExitApp
   }
   Else
      Reload
}
